/////////////////////////////////////////////////////////
// 3D Zylinder-Beispiel aus Kapitel Räumliche Strukturen
///////////////////////////////////////////////////// 
void setup()  { 
  size(500, 500, P3D); 
 stroke(0);
 strokeWeight(3);
} 
 
void draw()  { 
  background(255);
  lights();
  // verschiebe Objekt in Bildmitte
  translate(width/2, height/2, -30); 
  // rotiere um x-Achse je nach Höhe der Maus
  rotateX(map(mouseY,0,height,0,-TWO_PI)); 
  // rotiere um y-Achse je nach seitlicher Koordinate der Maus
  rotateY(map(mouseX,0,width,0,-TWO_PI));  
  fill(0,0,200,100);
  prisma(180);
  fill(200,0,0,200);
  pyramide(180);
} 

void prisma(float size) {
  float delta = TWO_PI / 8;
  beginShape(QUAD_STRIP);
  for (float angle = 0; angle < TWO_PI; angle+=delta) {
    vertex(size*cos(angle), -size/4, size*sin(angle));
    vertex(size*cos(angle), size/2, size*sin(angle));
  }
  //vertex(size, -size/2,0);
  //vertex(size, size/2,0);
  endShape();
}

void pyramide(float size) {
  float delta = TWO_PI / 8;
  beginShape();
  for (float angle = 0; angle < TWO_PI; angle+=delta) {
    vertex(0, -size-40, 0);
    vertex(size*cos(angle), -size/4, size*sin(angle));
    vertex(size*cos(angle+delta), -size/4, size*sin(angle+delta));
  }
  endShape();
}



  